Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontengine.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontengine.cpp
@@ -2287,34 +2243,29 @@ bool QFontEngineMulti::canRender(const Q
 /* Implement alphaMapForGlyph() which is called by Lighthouse/Windows code.
  * Ideally, that code should be fixed to correctly handle QFontEngineMulti. */
 
-QImage QFontEngineMulti::alphaMapForGlyph(glyph_t glyph)
+QImage QFontEngineMulti::alphaMapForGlyph(const QGlyph &glyph)
 {
-    const int which = highByte(glyph);
-    return engine(which)->alphaMapForGlyph(stripped(glyph));
+    return engine(glyph.engine)->alphaMapForGlyph(glyph);
 }
 
-QImage QFontEngineMulti::alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition)
+QImage QFontEngineMulti::alphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition)
 {
-    const int which = highByte(glyph);
-    return engine(which)->alphaMapForGlyph(stripped(glyph), subPixelPosition);
+    return engine(glyph.engine)->alphaMapForGlyph(glyph, subPixelPosition);
 }
 
-QImage QFontEngineMulti::alphaMapForGlyph(glyph_t glyph, const QTransform &t)
+QImage QFontEngineMulti::alphaMapForGlyph(const QGlyph &glyph, const QTransform &t)
 {
-    const int which = highByte(glyph);
-    return engine(which)->alphaMapForGlyph(stripped(glyph), t);
+    return engine(glyph.engine)->alphaMapForGlyph(glyph, t);
 }
 
-QImage QFontEngineMulti::alphaMapForGlyph(glyph_t glyph, QFixed subPixelPosition, const QTransform &t)
+QImage QFontEngineMulti::alphaMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition, const QTransform &t)
 {
-    const int which = highByte(glyph);
-    return engine(which)->alphaMapForGlyph(stripped(glyph), subPixelPosition, t);
+    return engine(glyph.engine)->alphaMapForGlyph(glyph, subPixelPosition, t);
 }
 
-QImage QFontEngineMulti::alphaRGBMapForGlyph(glyph_t glyph, QFixed subPixelPosition, const QTransform &t)
+QImage QFontEngineMulti::alphaRGBMapForGlyph(const QGlyph &glyph, QFixed subPixelPosition, const QTransform &t)
 {
-    const int which = highByte(glyph);
-    return engine(which)->alphaRGBMapForGlyph(stripped(glyph), subPixelPosition, t);
+    return engine(glyph.engine)->alphaRGBMapForGlyph(glyph, subPixelPosition, t);
 }
 
 /*
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfontdatabase.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfontdatabase.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfontdatabase.cpp
@@ -837,6 +837,7 @@ QStringList QPlatformFontDatabase::fallb
             }
         }
     }
+    qDebug()<< "fallbacksForFamily(" << family << "): " << preferredFallbacks << " ... " << otherFallbacks;
 
     return preferredFallbacks + otherFallbacks;
 }
@@ -871,6 +872,7 @@ static QStringList fallbacksForFamily(co
             --i;
         }
     }
+    qDebug()<< "fallbacksForFamily(" << family << "): " << retList;
 
     db->fallbacksCache.insert(cacheKey, new QStringList(retList));
 
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qtextengine.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qtextengine.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qtextengine.cpp
@@ -1455,7 +1455,7 @@ void QTextEngine::shapeText(int item) co
     if (fontEngine->type() == QFontEngine::Multi) {
         uint lastEngine = ~0u;
         for (int i = 0, glyph_pos = 0; i < itemLength; ++i, ++glyph_pos) {
-            const uint engineIdx = initialGlyphs.glyphs[glyph_pos] >> 24;
+            const uint engineIdx = initialGlyphs.glyphs[glyph_pos].engine;
             if (lastEngine != engineIdx) {
                 itemBoundaries.append(i);
                 itemBoundaries.append(glyph_pos);
@@ -1686,7 +1686,7 @@ int QTextEngine::shapeTextWithHarfbuzzNG
         uint last_cluster = ~0u;
         uint last_glyph_pos = glyphs_shaped;
         for (uint i = 0; i < num_glyphs; ++i, ++infos, ++positions) {
-            g.glyphs[i] = infos->codepoint;
+            g.glyphs[i] = {0, infos->codepoint};
 
             g.advances[i] = QFixed::fromFixed(positions->x_advance);
             g.offsets[i].x = QFixed::fromFixed(positions->x_offset);
@@ -1717,8 +1717,9 @@ int QTextEngine::shapeTextWithHarfbuzzNG
                         // U+00AD [SOFT HYPHEN] is a default ignorable codepoint,
                         // so we replace its glyph and metrics with ones for
                         // U+002D [HYPHEN-MINUS] and make it visible if it appears at line-break
-                        g.glyphs[i] = actualFontEngine->glyphIndex('-');
-                        if (Q_LIKELY(g.glyphs[i] != 0)) {
+                        QGlyph glyph = actualFontEngine->glyphIndex('-');
+                        g.glyphs[i] = glyph;
+                        if (Q_LIKELY(g.glyphs[i].glyph != 0)) {
                             QGlyphLayout tmp = g.mid(i, 1);
                             actualFontEngine->recalcAdvances(&tmp, 0);
                         }
@@ -1749,7 +1750,7 @@ int QTextEngine::shapeTextWithHarfbuzzNG
 
         if (Q_UNLIKELY(engineIdx != 0)) {
             for (quint32 i = 0; i < num_glyphs; ++i)
-                g.glyphs[i] |= (engineIdx << 24);
+                g.glyphs[i].engine = engineIdx;
         }
 
 #ifdef Q_OS_DARWIN
@@ -1784,14 +1785,14 @@ QT_BEGIN_INCLUDE_NAMESPACE
 
 QT_END_INCLUDE_NAMESPACE
 
-Q_STATIC_ASSERT(sizeof(HB_Glyph) == sizeof(glyph_t));
+Q_STATIC_ASSERT(sizeof(HB_Glyph) == sizeof(glyph__t));
 Q_STATIC_ASSERT(sizeof(HB_Fixed) == sizeof(QFixed));
 Q_STATIC_ASSERT(sizeof(HB_FixedPoint) == sizeof(QFixedPoint));
 
 static inline void moveGlyphData(const QGlyphLayout &destination, const QGlyphLayout &source, int num)
 {
     if (num > 0 && destination.glyphs != source.glyphs)
-        memmove(destination.glyphs, source.glyphs, num * sizeof(glyph_t));
+        memmove(destination.glyphs, source.glyphs, num * sizeof(QGlyph));
 }
 
 int QTextEngine::shapeTextWithHarfbuzz(const QScriptItem &si, const ushort *string, int itemLength, QFontEngine *fontEngine, const QVector<uint> &itemBoundaries, bool kerningEnabled) const
@@ -1870,7 +1871,7 @@ int QTextEngine::shapeTextWithHarfbuzz(c
 
             if (engineIdx != 0 && shaper_item.glyphIndicesPresent) {
                 for (quint32 i = 0; i < shaper_item.initialGlyphCount; ++i)
-                    shaper_item.glyphs[i] &= 0x00ffffff;
+                    shaper_item.glyphs[i] &= 0x003fffff;
             }
 
             shaper_item.log_clusters = logClusters(&si) + shaper_item.item.pos - entire_shaper_item.item.pos;
@@ -1900,7 +1901,7 @@ int QTextEngine::shapeTextWithHarfbuzz(c
 
         if (engineIdx != 0) {
             for (quint32 i = 0; i < shaper_item.num_glyphs; ++i)
-                g.glyphs[i] |= (engineIdx << 24);
+                g.glyphs[i].engine = engineIdx;
         }
 
         glyph_pos += shaper_item.num_glyphs;
@@ -2589,8 +2590,8 @@ static void set(QJustificationPoint *poi
     if (type >= Justification_Arabic_Normal) {
         QChar ch(0x640); // Kashida character
 
-        glyph_t kashidaGlyph = fe->glyphIndex(ch.unicode());
-        if (kashidaGlyph != 0) {
+        QGlyph kashidaGlyph = fe->glyphIndex(ch.unicode());
+        if (kashidaGlyph.glyph != 0) {
             QGlyphLayout g;
             g.numGlyphs = 1;
             g.glyphs = &kashidaGlyph;
@@ -2929,7 +2930,7 @@ void QGlyphLayout::grow(char *address, i
         memmove(newLayout.attributes, oldLayout.attributes, numGlyphs * sizeof(QGlyphAttributes));
         memmove(newLayout.justifications, oldLayout.justifications, numGlyphs * sizeof(QGlyphJustification));
         memmove(newLayout.advances, oldLayout.advances, numGlyphs * sizeof(QFixed));
-        memmove(newLayout.glyphs, oldLayout.glyphs, numGlyphs * sizeof(glyph_t));
+        memmove(newLayout.glyphs, oldLayout.glyphs, numGlyphs * sizeof(QGlyph));
     }
 
     // clear the new data
@@ -3220,20 +3221,20 @@ QString QTextEngine::elidedText(Qt::Text
             engine = multiEngine->engine(0);
         }
 
-        glyph_t glyph = engine->glyphIndex(ellipsisChar.unicode());
+        QGlyph glyph = engine->glyphIndex(ellipsisChar.unicode());
 
         QGlyphLayout glyphs;
         glyphs.numGlyphs = 1;
         glyphs.glyphs = &glyph;
         glyphs.advances = &ellipsisWidth;
 
-        if (glyph != 0) {
+        if (glyph.glyph != 0) {
             engine->recalcAdvances(&glyphs, 0);
 
             ellipsisText = ellipsisChar;
         } else {
             glyph = engine->glyphIndex('.');
-            if (glyph != 0) {
+            if (glyph.glyph != 0) {
                 engine->recalcAdvances(&glyphs, 0);
 
                 ellipsisWidth *= 3;
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qfont.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qfont.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qfont.cpp
@@ -67,7 +67,7 @@
 #include <QtCore/QMutexLocker>
 #include <QtCore/QMutex>
 
-// #define QFONTCACHE_DEBUG
+#define QFONTCACHE_DEBUG
 #ifdef QFONTCACHE_DEBUG
 #  define FC_DEBUG qDebug
 #else
Index: qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
+++ qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
@@ -784,7 +784,7 @@ QStringList QFontconfigDatabase::fallbac
         }
         FcFontSetDestroy(fontSet);
     }
-//    qDebug() << "fallbackFamilies for:" << family << style << styleHint << script << fallbackFamilies;
+    qDebug() << "fallbackFamilies for:" << family << style << styleHint << script << fallbackFamilies;
 
     return fallbackFamilies;
 }
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpainter.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpainter.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpainter.cpp
@@ -96,7 +96,7 @@ static void drawTextItemDecoration(QPain
                                    QTextItem::RenderFlags flags, qreal width,
                                    const QTextCharFormat &charFormat);
 // Helper function to calculate left most position, width and flags for decoration drawing
-Q_GUI_EXPORT void qt_draw_decoration_for_glyphs(QPainter *painter, const glyph_t *glyphArray,
+Q_GUI_EXPORT void qt_draw_decoration_for_glyphs(QPainter *painter, const QGlyph *glyphArray,
                                                 const QFixedPoint *positions, int glyphCount,
                                                 QFontEngine *fontEngine, const QFont &font,
                                                 const QTextCharFormat &charFormat);
@@ -5584,11 +5584,11 @@ void QPainter::drawGlyphRun(const QPoint
 
     QGlyphRunPrivate *glyphRun_d = QGlyphRunPrivate::get(glyphRun);
 
-    const quint32 *glyphIndexes = glyphRun_d->glyphIndexData;
-    const QPointF *glyphPositions = glyphRun_d->glyphPositionData;
-
     int count = qMin(glyphRun_d->glyphIndexDataSize, glyphRun_d->glyphPositionDataSize);
+
+    QVector <QGlyph> tmpGlyphIndexes(count);
     QVarLengthArray<QFixedPoint, 128> fixedPointPositions(count);
+    const QPointF *glyphPositions = glyphRun_d->glyphPositionData;
 
     QRawFontPrivate *fontD = QRawFontPrivate::get(font);
     bool engineRequiresPretransformedGlyphPositions = d->extended
@@ -5596,17 +5596,18 @@ void QPainter::drawGlyphRun(const QPoint
         : d->engine->type() != QPaintEngine::CoreGraphics && !d->state->matrix.isAffine();
 
     for (int i=0; i<count; ++i) {
+        tmpGlyphIndexes[i].glyph = glyphRun_d->glyphIndexData[i];
         QPointF processedPosition = position + glyphPositions[i];
         if (engineRequiresPretransformedGlyphPositions)
             processedPosition = d->state->transform().map(processedPosition);
         fixedPointPositions[i] = QFixedPoint::fromPointF(processedPosition);
     }
 
-    d->drawGlyphs(glyphIndexes, fixedPointPositions.data(), count, fontD->fontEngine,
+    d->drawGlyphs(tmpGlyphIndexes.constData(), fixedPointPositions.data(), count, fontD->fontEngine,
                   glyphRun.overline(), glyphRun.underline(), glyphRun.strikeOut());
 }
 
-void QPainterPrivate::drawGlyphs(const quint32 *glyphArray, QFixedPoint *positions,
+void QPainterPrivate::drawGlyphs(const QGlyph *glyphArray, QFixedPoint *positions,
                                  int glyphCount,
                                  QFontEngine *fontEngine, bool overline, bool underline,
                                  bool strikeOut)
@@ -5642,7 +5643,7 @@ void QPainterPrivate::drawGlyphs(const q
         staticTextItem.font = state->font;
         staticTextItem.setFontEngine(fontEngine);
         staticTextItem.numGlyphs = glyphCount;
-        staticTextItem.glyphs = reinterpret_cast<glyph_t *>(const_cast<glyph_t *>(glyphArray));
+        staticTextItem.glyphs = reinterpret_cast<QGlyph *>(const_cast<QGlyph *>(glyphArray));
         staticTextItem.glyphPositions = positions;
         // The font property is meaningless, the fontengine must be used directly:
         staticTextItem.usesRawFont = true;
@@ -5660,7 +5661,7 @@ void QPainterPrivate::drawGlyphs(const q
         memset(static_cast<void *>(glyphJustifications.data()), 0, glyphJustifications.size() * sizeof(QGlyphJustification));
 
         textItem.glyphs.numGlyphs = glyphCount;
-        textItem.glyphs.glyphs = const_cast<glyph_t *>(glyphArray);
+        textItem.glyphs.glyphs = const_cast<QGlyph *>(glyphArray);
         textItem.glyphs.offsets = positions;
         textItem.glyphs.advances = advances.data();
         textItem.glyphs.justifications = glyphJustifications.data();
@@ -6370,7 +6371,7 @@ static void drawTextItemDecoration(QPain
         painter->setRenderHint(QPainter::Qt4CompatiblePainting);
 }
 
-Q_GUI_EXPORT void qt_draw_decoration_for_glyphs(QPainter *painter, const glyph_t *glyphArray,
+Q_GUI_EXPORT void qt_draw_decoration_for_glyphs(QPainter *painter, const QGlyph *glyphArray,
                                                 const QFixedPoint *positions, int glyphCount,
                                                 QFontEngine *fontEngine, const QFont &font,
                                                 const QTextCharFormat &charFormat)
@@ -6488,7 +6489,7 @@ void QPainterPrivate::drawTextItem(const
         QFontEngineMulti *multi = static_cast<QFontEngineMulti *>(ti.fontEngine);
 
         const QGlyphLayout &glyphs = ti.glyphs;
-        int which = glyphs.glyphs[0] >> 24;
+        int which = glyphs.glyphs[0].engine;
 
         qreal x = p.x();
         qreal y = p.y();
@@ -6500,7 +6501,7 @@ void QPainterPrivate::drawTextItem(const
         int start = 0;
         int end, i;
         for (end = 0; end < ti.glyphs.numGlyphs; ++end) {
-            const int e = glyphs.glyphs[end] >> 24;
+            const int e = glyphs.glyphs[end].engine;
             if (e == which)
                 continue;
 
@@ -6508,11 +6509,9 @@ void QPainterPrivate::drawTextItem(const
             multi->ensureEngineAt(which);
             QTextItemInt ti2 = ti.midItem(multi->engine(which), start, end - start);
             ti2.width = 0;
-            // set the high byte to zero and calc the width
-            for (i = start; i < end; ++i) {
-                glyphs.glyphs[i] = glyphs.glyphs[i] & 0xffffff;
+            // Calculate the width
+            for (i = start; i < end; ++i)
                 ti2.width += ti.glyphs.effectiveAdvance(i);
-            }
 
             if (rtl)
                 x -= ti2.width.toReal();
@@ -6527,12 +6526,6 @@ void QPainterPrivate::drawTextItem(const
             if (!rtl)
                 x += ti2.width.toReal();
 
-            // reset the high byte for all glyphs and advance to the next sub-string
-            const int hi = which << 24;
-            for (i = start; i < end; ++i) {
-                glyphs.glyphs[i] = hi | glyphs.glyphs[i];
-            }
-
             // change engine
             start = end;
             which = e;
@@ -6541,11 +6534,9 @@ void QPainterPrivate::drawTextItem(const
         multi->ensureEngineAt(which);
         QTextItemInt ti2 = ti.midItem(multi->engine(which), start, end - start);
         ti2.width = 0;
-        // set the high byte to zero and calc the width
-        for (i = start; i < end; ++i) {
-            glyphs.glyphs[i] = glyphs.glyphs[i] & 0xffffff;
+        // Calculate the width
+        for (i = start; i < end; ++i)
             ti2.width += ti.glyphs.effectiveAdvance(i);
-        }
 
         if (rtl)
             x -= ti2.width.toReal();
@@ -6557,11 +6548,6 @@ void QPainterPrivate::drawTextItem(const
         drawTextItemDecoration(q, QPointF(x, y), ti2.fontEngine, textEngine, ti2.underlineStyle,
                                ti2.flags, ti2.width.toReal(), ti2.charFormat);
 
-        // reset the high byte for all glyphs
-        const int hi = which << 24;
-        for (i = start; i < end; ++i)
-            glyphs.glyphs[i] = hi | glyphs.glyphs[i];
-
     } else {
         if (extended)
             extended->drawTextItem(p, ti);
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qtextengine_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qtextengine_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qtextengine_p.h
@@ -86,7 +86,14 @@ class QPainter;
 
 class QAbstractTextDocumentLayout;
 
-typedef quint32 glyph_t;
+typedef quint32 engine_t;
+typedef quint32 glyph__t;
+
+struct QGlyph
+{
+    engine_t engine;
+    glyph__t glyph;
+};
 
 // this uses the same coordinate system as Qt, but a different one to freetype.
 // * y is usually negative, and is equal to the ascent.
@@ -195,13 +202,13 @@ Q_DECLARE_TYPEINFO(QGlyphAttributes, Q_P
 struct QGlyphLayout
 {
     enum {
-        SpaceNeeded = sizeof(glyph_t) + sizeof(QFixed) + sizeof(QFixedPoint)
+        SpaceNeeded = sizeof(QGlyph) + sizeof(QFixed) + sizeof(QFixedPoint)
                     + sizeof(QGlyphAttributes) + sizeof(QGlyphJustification)
     };
 
     // init to 0 not needed, done when shaping
     QFixedPoint *offsets; // 8 bytes per element
-    glyph_t *glyphs; // 4 bytes per element
+    QGlyph *glyphs; // 8 bytes per element
     QFixed *advances; // 4 bytes per element
     QGlyphJustification *justifications; // 4 bytes per element
     QGlyphAttributes *attributes; // 1 byte per element
@@ -214,8 +221,8 @@ struct QGlyphLayout
     {
         offsets = reinterpret_cast<QFixedPoint *>(address);
         int offset = totalGlyphs * sizeof(QFixedPoint);
-        glyphs = reinterpret_cast<glyph_t *>(address + offset);
-        offset += totalGlyphs * sizeof(glyph_t);
+        glyphs = reinterpret_cast<QGlyph *>(address + offset);
+        offset += totalGlyphs * sizeof(QGlyph);
         advances = reinterpret_cast<QFixed *>(address + offset);
         offset += totalGlyphs * sizeof(QFixed);
         justifications = reinterpret_cast<QGlyphJustification *>(address + offset);
@@ -250,7 +257,7 @@ struct QGlyphLayout
         } else {
             const int num = last - first;
             memset(static_cast<void *>(offsets + first), 0, num * sizeof(QFixedPoint));
-            memset(glyphs + first, 0, num * sizeof(glyph_t));
+            memset(glyphs + first, 0, num * sizeof(QGlyph));
             memset(static_cast<void *>(advances + first), 0, num * sizeof(QFixed));
             memset(static_cast<void *>(justifications + first), 0, num * sizeof(QGlyphJustification));
             memset(attributes + first, 0, num * sizeof(QGlyphAttributes));
@@ -261,6 +268,10 @@ struct QGlyphLayout
         return reinterpret_cast<char *>(offsets);
     }
 
+    inline QGlyph at(int position) const {
+        return glyphs[position];
+    }
+
     void grow(char *address, int totalGlyphs);
 };
 
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qblittable_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qblittable_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qblittable_p.h
@@ -105,7 +105,7 @@ public:
         Q_UNUSED(opacity);
         qWarning("Please implement drawPixmapOpacity function in your platform or remove OpacityPixmapCapability from it");
     }
-    virtual bool drawCachedGlyphs(const QPaintEngineState *state, QFontEngine::GlyphFormat glyphFormat, int numGlyphs, const glyph_t *glyphs, const QFixedPoint *positions, QFontEngine *fontEngine) {
+    virtual bool drawCachedGlyphs(const QPaintEngineState *state, QFontEngine::GlyphFormat glyphFormat, int numGlyphs, const QGlyph *glyphs, const QFixedPoint *positions, QFontEngine *fontEngine) {
         Q_UNUSED(state);
         Q_UNUSED(glyphFormat);
         Q_UNUSED(numGlyphs);
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpaintengine.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine.cpp
@@ -756,7 +756,7 @@ void QPaintEngine::drawTextItem(const QP
 
     if (ti.fontEngine->glyphFormat == QFontEngine::Format_ARGB) {
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> glyphs;
+        QVarLengthArray<QGlyph> glyphs;
         QTransform matrix = QTransform::fromTranslate(p.x(), p.y() - ti.fontEngine->ascent().toReal());
         ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
         painter()->save();
@@ -1007,7 +1007,7 @@ void QPaintEnginePrivate::drawBoxTextIte
     // any fixes here should probably also be done in QFontEngineBox::draw
     const int size = qRound(ti.fontEngine->ascent());
     QVarLengthArray<QFixedPoint> positions;
-    QVarLengthArray<glyph_t> glyphs;
+    QVarLengthArray<QGlyph> glyphs;
     QTransform matrix = QTransform::fromTranslate(p.x(), p.y() - size);
     ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
     if (glyphs.size() == 0)
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_blitter.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpaintengine_blitter.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_blitter.cpp
@@ -804,7 +804,7 @@ void QBlitterPaintEngine::drawStaticText
 #endif
 }
 
-bool QBlitterPaintEngine::drawCachedGlyphs(int numGlyphs, const glyph_t *glyphs, const QFixedPoint *positions, QFontEngine *fontEngine)
+bool QBlitterPaintEngine::drawCachedGlyphs(int numGlyphs, const QGlyph *glyphs, const QFixedPoint *positions, QFontEngine *fontEngine)
 {
     Q_D(QBlitterPaintEngine);
     QFontEngine::GlyphFormat glyphFormat = d->glyphCacheFormat;
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_blitter_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpaintengine_blitter_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_blitter_p.h
@@ -107,7 +107,7 @@ public:
     void drawPoints(const QPoint *points, int pointCount) override;
     void stroke(const QVectorPath &path, const QPen &pen) override;
     void drawStaticTextItem(QStaticTextItem *) override;
-    bool drawCachedGlyphs(int numGlyphs, const glyph_t *glyphs, const QFixedPoint *positions,
+    bool drawCachedGlyphs(int numGlyphs, const QGlyph *glyphs, const QFixedPoint *positions,
                           QFontEngine *fontEngine) override;
 };
 
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_raster.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpaintengine_raster.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_raster.cpp
@@ -2890,7 +2890,7 @@ void QRasterPaintEngine::alphaPenBlt(con
 /*!
     \internal
 */
-bool QRasterPaintEngine::drawCachedGlyphs(int numGlyphs, const glyph_t *glyphs,
+bool QRasterPaintEngine::drawCachedGlyphs(int numGlyphs, const QGlyph *glyphs,
                                           const QFixedPoint *positions, QFontEngine *fontEngine)
 {
     Q_D(QRasterPaintEngine);
@@ -3090,7 +3090,7 @@ QRasterPaintEnginePrivate::getPenFunc(co
 }
 
 static QPair<int, int> visibleGlyphRange(const QRectF &clip, QFontEngine *fontEngine,
-                                         glyph_t *glyphs, QFixedPoint *positions, int numGlyphs)
+                                         QGlyph *glyphs, QFixedPoint *positions, int numGlyphs)
 {
     QFixed clipLeft = QFixed::fromReal(clip.left());
     QFixed clipRight = QFixed::fromReal(clip.right());
@@ -3182,7 +3182,7 @@ void QRasterPaintEngine::drawTextItem(co
 
     if (shouldDrawCachedGlyphs(ti.fontEngine, matrix)) {
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> glyphs;
+        QVarLengthArray<QGlyph> glyphs;
 
         matrix.translate(p.x(), p.y());
         ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
@@ -3196,7 +3196,7 @@ void QRasterPaintEngine::drawTextItem(co
             return;
 
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> glyphs;
+        QVarLengthArray<QGlyph> glyphs;
 
         ti.fontEngine->getGlyphPositions(ti.glyphs, QTransform::fromTranslate(p.x(), p.y()),
                                          ti.flags, glyphs, positions);
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_raster_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpaintengine_raster_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpaintengine_raster_p.h
@@ -198,7 +198,7 @@ public:
     inline const QClipData *clipData() const;
 
     void drawStaticTextItem(QStaticTextItem *textItem) override;
-    virtual bool drawCachedGlyphs(int numGlyphs, const glyph_t *glyphs, const QFixedPoint *positions,
+    virtual bool drawCachedGlyphs(int numGlyphs, const QGlyph *glyphs, const QFixedPoint *positions,
                                   QFontEngine *fontEngine);
 
     enum ClipType {
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qtextureglyphcache_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qtextureglyphcache_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qtextureglyphcache_p.h
@@ -64,7 +64,7 @@
 #endif
 
 struct glyph_metrics_t;
-typedef unsigned int glyph_t;
+typedef unsigned int glyph__t;
 
 
 QT_BEGIN_NAMESPACE
@@ -83,14 +83,14 @@ public:
 
     struct GlyphAndSubPixelPosition
     {
-        GlyphAndSubPixelPosition(glyph_t g, QFixed spp) : glyph(g), subPixelPosition(spp) {}
+        GlyphAndSubPixelPosition(const QGlyph &g, QFixed spp) : glyph(g), subPixelPosition(spp) {}
 
         bool operator==(const GlyphAndSubPixelPosition &other) const
         {
-            return glyph == other.glyph && subPixelPosition == other.subPixelPosition;
+            return glyph.glyph == other.glyph.glyph && subPixelPosition == other.subPixelPosition;
         }
 
-        glyph_t glyph;
+        QGlyph glyph;
         QFixed subPixelPosition;
     };
 
@@ -109,7 +109,7 @@ public:
         }
     };
 
-    bool populate(QFontEngine *fontEngine, int numGlyphs, const glyph_t *glyphs,
+    bool populate(QFontEngine *fontEngine, int numGlyphs, const QGlyph *glyphs,
                   const QFixedPoint *positions);
     bool hasPendingGlyphs() const { return !m_pendingGlyphs.isEmpty(); };
     void fillInPendingGlyphs();
@@ -119,7 +119,7 @@ public:
     virtual int glyphPadding() const { return 0; }
 
     virtual void beginFillTexture() { }
-    virtual void fillTexture(const Coord &coord, glyph_t glyph, QFixed subPixelPosition) = 0;
+    virtual void fillTexture(const Coord &coord, const QGlyph &glyph, QFixed subPixelPosition) = 0;
     virtual void endFillTexture() { }
 
     inline void createCache(int width, int height) {
@@ -141,10 +141,10 @@ public:
     virtual int maxTextureWidth() const { return QT_DEFAULT_TEXTURE_GLYPH_CACHE_WIDTH; }
     virtual int maxTextureHeight() const { return -1; }
 
-    QImage textureMapForGlyph(glyph_t g, QFixed subPixelPosition) const;
+    QImage textureMapForGlyph(const QGlyph &g, QFixed subPixelPosition) const;
 
 protected:
-    int calculateSubPixelPositionCount(glyph_t) const;
+    int calculateSubPixelPositionCount(const QGlyph &) const;
 
     QFontEngine *m_current_fontengine;
     QHash<GlyphAndSubPixelPosition, Coord> m_pendingGlyphs;
@@ -158,7 +158,7 @@ protected:
 
 inline uint qHash(const QTextureGlyphCache::GlyphAndSubPixelPosition &g)
 {
-    return (g.glyph << 8)  | (g.subPixelPosition * 10).round().toInt();
+    return (g.glyph.glyph << 8)  | (g.subPixelPosition * 10).round().toInt();
 }
 
 
@@ -171,7 +171,7 @@ public:
 
     virtual void createTextureData(int width, int height) override;
     virtual void resizeTextureData(int width, int height) override;
-    virtual void fillTexture(const Coord &c, glyph_t glyph, QFixed subPixelPosition) override;
+    virtual void fillTexture(const Coord &c, const QGlyph &glyph, QFixed subPixelPosition) override;
 
     inline const QImage &image() const { return m_image; }
 
